#include "IZ_app.h"

void IZ_AppHandleSignal(i32 _signal) {
	interrupted = true;
}

void IZ_AppCreateContext(IZ_App* app) {
	struct lws_context_creation_info info;
	memset(&info, 0, sizeof info);
	info.port = app->config.port;
	// TODO initialize protocols
	info.options = (
		LWS_SERVER_OPTION_VALIDATE_UTF8
		| LWS_SERVER_OPTION_HTTP_HEADERS_SECURITY_BEST_PRACTICES_ENFORCE
	);
}

void IZ_AppLoadConfig(IZ_App* app, u8 argc, const char** argv) {
	memcpy_s(app, sizeof(IZ_App), &IZ_APP_DEFAULT_STATE, sizeof(IZ_App));

	const char* cmdline_buffer;
	if ((cmdline_buffer = lws_cmdline_option(argc, argv, "-d"))) {
		app->config.log_level = atoi(cmdline_buffer);
	}

	if ((cmdline_buffer = lws_cmdline_option(argc, argv, "-p"))) {
		app->config.port = atoi(cmdline_buffer);
	}

	if (lws_cmdline_option(argc, argv, "-o")) {
		// connect once
		app->config.vhost_options |= 1;
	}

	if (!lws_cmdline_option(argc, argv, "-n")) {
		app->config.extensions_enabled = true;
	}
}

IZ_ProcedureResult IZ_AppInitialize(IZ_App* app, u8 argc, const char** argv) {
	interrupted = false;
	signal(SIGINT, IZ_AppHandleSignal);

	IZ_AppLoadConfig(app, argc, argv);
	IZ_LogInterceptWSMessages(app->config.log_level);
	IZ_AppCreateContext(app);

	return 0;
}

IZ_ProcedureResult IZ_AppRun(IZ_App* app, u8 argc, const char** argv) {
	if (IZ_AppInitialize(app, argc, argv)) {
		return 1;
	}

	return 0;
}
